/*
 * AdminGUI.java
 *
 * Created on 23. květen 2006, 22:03
 */

package cz.vse.xkucf03.slovnik.admin;

import cz.vse.xkucf03.slovnik.*;
import cz.vse.xkucf03.slovnik.db.Jazyk;
import java.awt.List;
import java.sql.SQLException;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.TableModel;

/**
 *
 * @author  fiki
 */
public class AdminGUI extends javax.swing.JFrame {
    
    Data d;
    
    /** příznaky, podle kterých se buď vytvoří nový záznam nebo aktualizuje stávající */
    private boolean nJazyk = false;
    private boolean nKategorie = false;
    private boolean nOblibene = false;
    private boolean nPreklad = false;
    private boolean nSlovniDruh = false;
    private boolean nSlovo = false;
    private boolean nUzivatel = false;
    
    /** Creates new form AdminGUI */
    public AdminGUI(Data d) {
        this.d = d;
        initComponents();
        
        tabulkaJazyku.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tabulkaJazyku.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                try {
                    setJazykNovy(false);
                    Jazyk j = ((ModelJazyku)tabulkaJazyku.getModel()).getJazyk(tabulkaJazyku.getSelectedRow());
                    textKodJazyka.setText(j.kodJazyka);
                    textNazevJazyka.setText(j.nazevJazyka);
                    textPrislovce.setText(j.prislovce);
                    textDruhyPad.setText(j.druhyPad);
                    
                } catch (Exception ex) {}
            }
        });
        nactiTabulkuJazyku();
        
    }
    
    private void setJazykNovy(boolean b) {
        nJazyk = b;
        textKodJazyka.setEnabled(b);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelKategorii = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        tabulkaKategorii = new javax.swing.JTable();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        textZkratka = new javax.swing.JTextField();
        textNazevKategorie = new javax.swing.JTextField();
        textPopisKategorie = new javax.swing.JTextField();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        panelJazyk = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tabulkaJazyku = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        textKodJazyka = new javax.swing.JTextField();
        textNazevJazyka = new javax.swing.JTextField();
        textPrislovce = new javax.swing.JTextField();
        textDruhyPad = new javax.swing.JTextField();
        smazatJazyk = new javax.swing.JButton();
        ulozitJazyk = new javax.swing.JButton();
        novyJazyk = new javax.swing.JButton();
        panelOstatni = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();

        tabulkaKategorii.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        jScrollPane2.setViewportView(tabulkaKategorii);

        jButton1.setText("Smazat");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("Ulo\u017eit");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("Nov\u00e1");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jLabel5.setText("Zkratka");

        jLabel6.setText("N\u00e1zev");

        jLabel7.setText("Popis");

        textZkratka.setEnabled(false);

        org.jdesktop.layout.GroupLayout panelKategoriiLayout = new org.jdesktop.layout.GroupLayout(panelKategorii);
        panelKategorii.setLayout(panelKategoriiLayout);
        panelKategoriiLayout.setHorizontalGroup(
            panelKategoriiLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelKategoriiLayout.createSequentialGroup()
                .addContainerGap(156, Short.MAX_VALUE)
                .add(jButton3)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton2)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton1)
                .addContainerGap())
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelKategoriiLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelKategoriiLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel5)
                    .add(jLabel7)
                    .add(jLabel6))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelKategoriiLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(textNazevKategorie, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 311, Short.MAX_VALUE)
                    .add(textZkratka, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 311, Short.MAX_VALUE)
                    .add(textPopisKategorie, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 311, Short.MAX_VALUE))
                .addContainerGap())
            .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 395, Short.MAX_VALUE)
        );
        panelKategoriiLayout.setVerticalGroup(
            panelKategoriiLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelKategoriiLayout.createSequentialGroup()
                .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 183, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelKategoriiLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel5)
                    .add(panelKategoriiLayout.createSequentialGroup()
                        .add(textZkratka, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(panelKategoriiLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(textNazevKategorie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel6))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(panelKategoriiLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(textPopisKategorie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel7))))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelKategoriiLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton1)
                    .add(jButton2)
                    .add(jButton3))
                .addContainerGap())
        );

        setTitle("Spr\u00e1va slovn\u00edku");
        tabulkaJazyku.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        jScrollPane1.setViewportView(tabulkaJazyku);

        jLabel1.setText("K\u00f3d jazyka");

        jLabel2.setText("N\u00e1zev");

        jLabel3.setText("P\u0159\u00edslovce");

        jLabel4.setText("Druh\u00fd p\u00e1d");

        textKodJazyka.setEnabled(false);

        textPrislovce.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textPrislovceActionPerformed(evt);
            }
        });

        smazatJazyk.setText("Smazat");
        smazatJazyk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                smazatJazykActionPerformed(evt);
            }
        });

        ulozitJazyk.setText("Ulo\u017eit");
        ulozitJazyk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ulozitJazykActionPerformed(evt);
            }
        });

        novyJazyk.setText("Nov\u00fd");
        novyJazyk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                novyJazykActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout panelJazykLayout = new org.jdesktop.layout.GroupLayout(panelJazyk);
        panelJazyk.setLayout(panelJazykLayout);
        panelJazykLayout.setHorizontalGroup(
            panelJazykLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelJazykLayout.createSequentialGroup()
                .addContainerGap(156, Short.MAX_VALUE)
                .add(novyJazyk)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(ulozitJazyk)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(smazatJazyk)
                .addContainerGap())
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelJazykLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelJazykLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel1)
                    .add(jLabel2)
                    .add(jLabel3)
                    .add(jLabel4))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelJazykLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, textNazevJazyka, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 290, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, textKodJazyka, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 290, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, textPrislovce, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 290, Short.MAX_VALUE)
                    .add(textDruhyPad, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 290, Short.MAX_VALUE))
                .addContainerGap())
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 395, Short.MAX_VALUE)
        );
        panelJazykLayout.setVerticalGroup(
            panelJazykLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelJazykLayout.createSequentialGroup()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelJazykLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(textKodJazyka, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelJazykLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(textNazevJazyka, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelJazykLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(textPrislovce, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelJazykLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel4)
                    .add(textDruhyPad, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelJazykLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(smazatJazyk)
                    .add(ulozitJazyk)
                    .add(novyJazyk))
                .addContainerGap())
        );
        jTabbedPane1.addTab("Jazyky", panelJazyk);

        jLabel8.setText("<html> V\u0161echny tabulky jde upravovat p\u0159\u00edmo zm\u011bnami v datab\u00e1zi.<br> O integritu se staraj\u00ed omezen\u00ed na stran\u011b DB<br> Tak\u017ee jde k prov\u00e1d\u011bn\u00ed zm\u011bn pou\u017e\u00edt t\u0159eba SQL Developer.</html>");

        org.jdesktop.layout.GroupLayout panelOstatniLayout = new org.jdesktop.layout.GroupLayout(panelOstatni);
        panelOstatni.setLayout(panelOstatniLayout);
        panelOstatniLayout.setHorizontalGroup(
            panelOstatniLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelOstatniLayout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel8, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 371, Short.MAX_VALUE)
                .addContainerGap())
        );
        panelOstatniLayout.setVerticalGroup(
            panelOstatniLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelOstatniLayout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel8)
                .addContainerGap(244, Short.MAX_VALUE))
        );
        jTabbedPane1.addTab("Ostatn\u00ed tabulky", panelOstatni);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_jButton3ActionPerformed
    
    private boolean isJazykNovy() {
        return nJazyk;
    }
    
    private void ulozitJazykActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ulozitJazykActionPerformed
        try {
            Jazyk j = new Jazyk(textKodJazyka.getText(), textNazevJazyka.getText(), textPrislovce.getText(), textDruhyPad.getText());
            j.novy = isJazykNovy();
            d.ulozJazyk(j);
            nactiTabulkuJazyku();
        } catch (SQLException e) {
            zobrazChybu(e, "Uložení jazyka");
        }
    }//GEN-LAST:event_ulozitJazykActionPerformed
    
    private void zobrazChybu(Exception e, String titulek) {
        
        if (e instanceof SQLException) {
            System.out.println(((SQLException)e).getSQLState());
        }
        
        e.printStackTrace();
        
        JOptionPane.showMessageDialog(this, e.getLocalizedMessage(),  titulek, JOptionPane.ERROR_MESSAGE);
    }
    
    private void smazatJazykActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_smazatJazykActionPerformed
        try {
            d.smazJazyk(((ModelJazyku)tabulkaJazyku.getModel()).getJazyk(tabulkaJazyku.getSelectedRow()));
            nactiTabulkuJazyku();
        } catch (SQLException e) {
            zobrazChybu(e, "Mazání jazyka");
        }
    }//GEN-LAST:event_smazatJazykActionPerformed
    
    private void novyJazykActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_novyJazykActionPerformed
        vynulujPoleJazyku();
    }//GEN-LAST:event_novyJazykActionPerformed
    
    private TableModel getModelJazyku() throws SQLException {
        return new ModelJazyku(d.getJazyky());
    }
    
    private TableModel getModelKategorii() throws SQLException {
        return new ModelKategorii(d.getKategorie());
    }
    
    private void vynulujPoleJazyku() {
        textKodJazyka.setText("");
        textNazevJazyka.setText("");
        textPrislovce.setText("");
        textDruhyPad.setText("");
        setJazykNovy(true);
    }
    
    private void nactiTabulkuJazyku() {
        try {
            tabulkaJazyku.setModel(getModelJazyku());
            vynulujPoleJazyku();
            
        } catch (SQLException ex) {
            ex.printStackTrace();
        }
    }
    
    private void textPrislovceActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textPrislovceActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_textPrislovceActionPerformed
    
    /**
     * @param args the command line arguments
     *
     * public static void main(String args[]) {
     * java.awt.EventQueue.invokeLater(new Runnable() {
     * public void run() {
     * new AdminGUI().setVisible(true);
     * }
     * });
     * }
     */
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JButton novyJazyk;
    private javax.swing.JPanel panelJazyk;
    private javax.swing.JPanel panelKategorii;
    private javax.swing.JPanel panelOstatni;
    private javax.swing.JButton smazatJazyk;
    private javax.swing.JTable tabulkaJazyku;
    private javax.swing.JTable tabulkaKategorii;
    private javax.swing.JTextField textDruhyPad;
    private javax.swing.JTextField textKodJazyka;
    private javax.swing.JTextField textNazevJazyka;
    private javax.swing.JTextField textNazevKategorie;
    private javax.swing.JTextField textPopisKategorie;
    private javax.swing.JTextField textPrislovce;
    private javax.swing.JTextField textZkratka;
    private javax.swing.JButton ulozitJazyk;
    // End of variables declaration//GEN-END:variables
    
}
